program _Pexeso_;
uses
  graph, crt, mouse, un_kbd;

const
  jmena: array[1..30] of string[15] = ('Motk', 'Trouba', 'Budulnek',
    'Hloup Honza', 'Trdlo', 'Magor', 'Homer Simpson', 'Bart Simpson',
    'Glum', 'Peek', 'Smola Smlne', 'Janek', 'Ignc', 'Igor', 'Frantk',
    'Kudislav', 'Chocholouek', 'Vojtk Raketka', 'Matj', 'Dr. Watson',
    'Harry Potter', 'H. Grangerov', 'Ron Weasley', 'Ruda', 'D`Artagnan',
    'Athos', 'Porthos', 'Aramis', 'Sherlock Holmes', 'Vt');

type
  tobr = record
           bitmap: array[0..57, 0..57] of byte;
           nazev : string[28];
         end;
  tbig = record
           bitmap: array[0..234, 0..93] of byte;
           nazev : string[8];
         end;
  tsmall = record
           bitmap: array[0..141, 0..31] of byte;
           nazev : string[8];
         end;
  tpoc = record
           pole                   : array[1..64] of byte;
           uroven, spatne, spravne: byte;
           jmeno                  : string[15];
         end;
  tclov = record
           spatne, spravne: byte;
           jmeno          : string[15];
         end;

var
  gd, gm, px, py: integer;
  pexobr        : array[0..32] of ^tobr;
  pexbig        : ^tbig;
  pexsmall      : ^tsmall;
  i, j, k, pocpoc,
  poccom, pocpor,
  rada          : byte;
  pole          : array[1..64] of byte;
  otoc          : array[1..64] of boolean;
  nechpex, prog,
  cheat         : boolean;
  clovek        : array[1..6] of tclov;
  pocitac       : array[1..6] of tpoc;
  poradi        : array[1..6] of byte;
  cfgfile       : file of boolean;

procedure vgadriver; external; {$l egavga.obj}

procedure uvolnipamet;
begin
  dispose(pexsmall);
  dispose(pexbig);
  for i := 32 downto 0 do dispose(pexobr[i]);
end;

procedure zaberpamet;
begin
  for i := 0 to 32 do new(pexobr[i]);
  new(pexbig);
  new(pexsmall);
end;

procedure nactiobrazky;
var
  pexf   : file of tobr;
  pexb   : file of tbig;
  pexs   : file of tsmall;
begin
  write('Natn obrzk: ');
  assign(pexf, 'PEXESO.OBR');
  {$i-}
  reset(pexf);
  {$i+}
  if ioresult <> 0 then
  begin
    uvolnipamet;
    writeln('Chyba pi natn obrzk!');
    halt;
  end;
  for i := 0 to 32 do
  begin
    read(pexf, pexobr[i]^);
    write('.');
  end;
  close(pexf);
  assign(pexb, 'PEXESOB.OBR');
  {$i-}
  reset(pexb);
  {$i+}
  if ioresult <> 0 then
  begin
    uvolnipamet;
    writeln('Chyba pi natn obrzk!');
    halt;
  end;
  read(pexb, pexbig^);
  close(pexb);
  write('.');
  assign(pexs, 'PEXESOS.OBR');
  {$i-}
  reset(pexs);
  {$i+}
  if ioresult <> 0 then
  begin
    uvolnipamet;
    writeln('Chyba pi natn obrzk!');
    halt;
  end;
  read(pexs, pexsmall^);
  close(pexs);
  write('.');
  writeln('Ok');
end;

procedure shadowtext(x, y: integer; txt: string; size, color: byte);
begin
  settextstyle(defaultfont, horizdir, size);
  setcolor(8);
  outtextxy(x+1, y+1, txt);
  setcolor(15);
  outtextxy(x-1, y-1, txt);
  setcolor(color);
  outtextxy(x, y, txt);
end;

procedure nakpex(cislo: byte; kamx, kamy: integer);
var
 o, p: byte;
begin
  if cislo < 33 then
  begin
    for p := 0 to 57 do
      for o := 0 to 57 do
        putpixel(o+kamx, p+kamy, pexobr[cislo]^.bitmap[o, p]);
  end
  else
  begin
    setfillstyle(1, 7);
    bar(kamx, kamy, kamx+57, kamy+57);
  end;
end;

procedure naknap(cislo: byte; kamx, kamy: integer);
var
  o, p: byte;
begin
  case cislo of
    1: for p := 0 to 31 do
         for o := 0 to 141 do
           putpixel(o+kamx, p+kamy, pexsmall^.bitmap[o, p]);
    2: for p := 0 to 93 do
         for o := 0 to 234 do
           putpixel(o+kamx, p+kamy, pexbig^.bitmap[o, p]);
    3: begin
         settextstyle(defaultfont, horizdir, 2);
         setfillstyle(1, 1);
         bar(kamx, kamy, kamx+49, kamy+18);
         setcolor(15);
         outtextxy(kamx+2, kamy+2, 'ham');
         setcolor(12);
         outtextxy(kamx+64, kamy+2, 'SOFTWARE');
       end;
    4: begin
         settextstyle(defaultfont, horizdir, 1);
         setfillstyle(1, 1);
         bar(kamx, kamy, kamx+24, kamy+9);
         setcolor(15);
         outtextxy(kamx+1, kamy+1, 'ham');
         setcolor(12);
         outtextxy(kamx+32, kamy+1, 'SOFTWARE');
       end;
  end;
end;

procedure uvod;
begin
  naknap(2, 202, 193);
  naknap(3, 224, 140);
end;

procedure nakporadi;
var
  pomstr    : string;
  pi, pj, pk: byte;
begin
  mhide;
  py := 60;
  pj := 0;
  pk := 0;
  for pi := 1 to pocpor do
  begin
    setcolor(8);
    rectangle(480, py, getmaxx-8, py+60);
    if poradi[pi] = 1 then
    begin
      inc(pj);
      if rada = pi then
        shadowtext(483, py+3, clovek[pj].jmeno, 1, 9)
      else
        shadowtext(483, py+3, clovek[pj].jmeno, 1, 1);
      setcolor(8);
      outtextxy(483, py+24, 'Sprvn:');
      outtextxy(483, py+44, 'patn :');
      setfillstyle(1, 7);
      bar(552, py+16, getmaxx-9, py+56);
      str(clovek[pj].spravne, pomstr);
      shadowtext(553, py+17, pomstr, 2, 2);
      str(clovek[pj].spatne, pomstr);
      shadowtext(553, py+38, pomstr, 2, 12);
    end
    else
    begin
      inc(pk);
      if rada = pi then
        shadowtext(483, py+3, pocitac[pk].jmeno, 1, 9)
      else
        shadowtext(483, py+3, pocitac[pk].jmeno, 1, 1);
      setcolor(8);
      outtextxy(483, py+24, 'Sprvn:');
      outtextxy(483, py+44, 'patn :');
      setfillstyle(1, 7);
      bar(552, py+16, getmaxx-9, py+56);
      str(pocitac[pk].spravne, pomstr);
      shadowtext(553, py+17, pomstr, 2, 2);
      str(pocitac[pk].spatne, pomstr);
      shadowtext(553, py+38, pomstr, 2, 12);
    end;
    py := py + 63;
  end;
  mshow;
end;

procedure nakpole(jak: boolean);
begin
  mhide;
  setfillstyle(1, 7);
  bar(2, 2, getmaxx-2, getmaxy-2);
  naknap(1, getmaxx-145, 4);
  naknap(4, getmaxx-99, getmaxy-12);
  nakporadi;
  k := 1;
  py := 4;
  for j := 0 to 7 do
  begin
    px := 4;
    for i := 0 to 7 do
    begin
      if jak then nakpex(0, px, py)
      else nakpex(pole[k], px, py);
      px := px + 59;
      inc(k);
    end;
    py := py + 59;
  end;
  mshow;
end;

procedure nakotoc;
begin
  mhide;
  k := 1;
  py := 4;
  for j := 0 to 7 do
  begin
    px := 4;
    for i := 0 to 7 do
    begin
      if not otoc[k] then
        if nechpex then nakpex(pole[k], px, py)
        else nakpex(33, px, py);
      px := px + 59;
      inc(k);
    end;
    py := py + 59;
  end;
  mshow;
end;

procedure napoveda(stranka: byte);
const
  textik1: array[0..19, 0..33] of char = ('Nyn  mte  ped  sebou  startovn',
                                          'listinu.                          ',
                                          'Kliknutm levho  tlatka myi na',
                                          'jedno  z  pol  mete  zadat  sv',
                                          'jmno,  kliknutm pravho tlatka',
                                          'myi na przdn pole  zvolte jako',
                                          'hre   pota   (stiskem  1 .. 5',
                                          'vyberete jeho rove;  1 nejhor,',
                                          '5 nejlep).                      ',
                                          'Kliknutm pravho tlatka myi na',
                                          'pln pole ho vynulujete.          ',
                                          'Kliknutm  pravho  tlatka  myi',
                                          'kamkoliv jinam se objev menu, po-',
                                          'moc  kterho lze ukonit program,',
                                          'nastavit  si  parametry  hry (jako',
                                          'je  napklad nechvn uhodnutch',
                                          'kartiek   na  hrac   ploe),  i',
                                          'vyvolat npovdu.                 ',
                                          '                                  ',
                                          'Vce info v souboru PEXESO.DOC.   ');
  textik2: array[0..19, 0..33] of char = ('Nyn   ped  sebou   vidte  hrac',
                                          'plochu,  na  kter  jsou vyrovnan',
                                          'kartiky.',
                                          'Kliknutm levho tlatka  myi na',
                                          'jednu z kartiek ji otote. Pokud',
                                          'jsou ji otoen dv kartiky, tak',
                                          'po kliknut zmiz.  Pokud je neod-',
                                          'kliknete  zmiz samy po  cca tech',
                                          'vteinch.',
                                          'Jestlie je na ad pota, ot',
                                          'kartiky,  kter  mete  opt od-',
                                          'kliknout nebo pokat a zmiz.    ',
                                          'Napravo je tabulka, kde je svtle-',
                                          'mode zvraznn  hr, kter je na',
                                          'tahu.',
                                          'Pokud program del dobu nepracuje',
                                          'a   nereaguje   na  Vae  pkazy,',
                                          'stisknte Ctrl + Pause.           ',
                                          'Stiskem pravho tlatka myi opt',
                                          'vyvolte menu.                    ');
var
  pozadi: pointer;
begin
  px := x;
  if x + 320 > getmaxx-5 then px := getmaxx-325;
  if x < 5 then px := 5;
  py := y;
  if y + 200 > getmaxy-5 then py := getmaxy-205;
  if y < 5 then py := 5;
  mhide;
  getmem(pozadi, 64000);
  getimage(px, py, px+320, py+200, pozadi^);
  setcolor(8);
  rectangle(px, py, px+320, py+200);
  setfillstyle(1, 6);
  bar(px+1, py+1, px+319, py+199);
  shadowtext(px+2, py+2, 'Npovda', 1, 12);
  setcolor(8);
  settextstyle(defaultfont, horizdir, 1);
  for j := 0 to 19 do
    for i := 0 to 33 do
      case stranka of
        1: outtextxy(px+4+9*i, py+12+9*j, textik1[j, i]);
        2: outtextxy(px+4+9*i, py+12+9*j, textik2[j, i]);
      end;
  mshow;
  pressanykey;
  mhide;
  putimage(px, py, pozadi^, normalput);
  freemem(pozadi, 64000);
  mshow;
end;

procedure menu(var konec: boolean; nap: byte);
var
  pozadi: pointer;
  velike: word;
  odejit: byte;
  pom   : boolean;
 procedure naknabidku;
 begin
   setcolor(8);
   rectangle(px, py, px+230, py+50);
   setfillstyle(1, 7);
   bar(px+1, py+1, px+229, py+49);
   if nechpex then
     shadowtext(px+4, py+4, 'Nechvat uhodnut karty: Ano', 1, 3)
   else
     shadowtext(px+4, py+4, 'Nechvat uhodnut karty:  Ne', 1, 3);
   shadowtext(px+4, py+14, 'Npovda', 1, 3);
   shadowtext(px+4, py+24, 'Jdi do OS', 1, 12);
   shadowtext(px+4, py+40, 'Zpt', 1, 2);
 end;
begin
  mhide;
  px := x;
  if x + 230 > getmaxx-5 then px := getmaxx-235;
  if x < 5 then px := 5;
  py := y;
  if y + 50 > getmaxy-5 then py := getmaxy-55;
  if y < 5 then py := 5;
  velike := imagesize(px, py, px+230, py+50);
  getmem(pozadi, velike);
  getimage(px, py, px+230, py+50, pozadi^);
  naknabidku;
  mshow;
  odejit := 0;
  repeat
    cekejakci(pom);
    if mouseloc.buttonstatus = leftbutton then ltlac := true;
    if (mouseloc.buttonstatus <> leftbutton) and
      (mouseloc.buttonstatus <> rightbutton) and ltlac then
    begin
      ltlac := false;
      if inside(px+3, py+3, px+227, py+12, x, y) then
      begin
        if nechpex then nechpex := false
        else nechpex := true;
        mhide;
        naknabidku;
        mshow;
      end;
      if inside(px+3, py+13, px+68, py+22, x, y) then odejit := 2;
      if inside(px+3, py+23, px+76, py+32, x, y) then odejit := 1;
      if inside(px+3, py+39, px+36, py+49, x, y) then odejit := 3;
    end;
    if mouseloc.buttonstatus = rightbutton then rtlac := true;
    if (mouseloc.buttonstatus <> rightbutton) and
      (mouseloc.buttonstatus <> leftbutton) and rtlac then
    begin
      rtlac := false;
      odejit := 3;
    end;
    if keypressed then
    begin
      mojekl := kbd;
      if mojekl = 27 then odejit := 3;
      nuluj;
    end;
  until (odejit = 1) or (odejit = 2) or (odejit = 3);
  if odejit = 1 then konec := true
  else konec := false;
  mhide;
  putimage(px, py, pozadi^, normalput);
  freemem(pozadi, velike);
  mshow;
  if odejit = 2 then napoveda(nap);
end;

procedure prohlednout;
var
  pom: boolean;
begin
  mhide;
  setfillstyle(1, 7);
  bar(2, 2, getmaxx-2, getmaxy-2);
  shadowtext(95, 4, 'Znaky mst eska a Slovenska', 2, 6);
  shadowtext(79, getmaxy-13, 'Klikni levm tlatkem na obrzek pro zobrazen jmna msta.', 1, 1);
  k := 0;
  py := 30;
  for j := 0 to 3 do
  begin
    px := 11;
    for i := 0 to 7 do
    begin
      inc(k);
      nakpex(k, px, py);
      px := px + 80;
    end;
    py := py + 80;
  end;
  mshow;
  cheat := false;
  repeat
    cekejakci(pom);
    if mouseloc.buttonstatus = leftbutton then ltlac := true;
    if (mouseloc.buttonstatus <> leftbutton) and
      (mouseloc.buttonstatus <> rightbutton) and ltlac then
    begin
      ltlac := false;
      k := 0;
      py := 30;
      for j := 0 to 3 do
      begin
        px := 11;
        for i := 0 to 7 do
        begin
          inc(k);
          if inside(px, py, px+58, py+58, x, y) then
          begin
            setfillstyle(1, 7);
            bar(94, 379, 543, 397);
            shadowtext(95, 380, pexobr[k]^.nazev, 2, 2);
          end;
          px := px + 80;
        end;
        py := py + 80;
      end;
    end;
    if mouseloc.buttonstatus = rightbutton then rtlac := true;
    if (mouseloc.buttonstatus <> rightbutton) and
      (mouseloc.buttonstatus <> leftbutton) and rtlac then
    begin
      rtlac := false;
      cheat := true;
    end;
    if keypressed then
    begin
      mojekl := kbd;
      if mojekl = 27 then cheat := true;
      nuluj;
    end;
  until cheat;
  cheat := false;
end;

procedure novahra;
var
  hotovo: boolean;
begin
  for i := 1 to 64 do pole[i] := 0;
  for i := 1 to 32 do
  begin
    for j := 1 to 2 do
    begin
      hotovo := false;
      repeat
        k := random(64) + 1;
        if pole[k] = 0 then hotovo := true;
      until hotovo;
      pole[k] := i;
    end;
  end;
  for i := 1 to 64 do otoc[i] := true;
  nakpole(true);
end;

procedure hra;
var
  pom, konec             : boolean;
  otocena1, otocena2, poc: byte;
  k1x, k1y, k2x, k2y     : integer;
  pp, pq, poc1, poc2     : byte;
 procedure otockarty;
 var
   po: byte;
 begin
   if pole[otocena1] <> pole[otocena2] then
   begin
     mhide;
     nakpex(0, k1x, k1y);
     nakpex(0, k2x, k2y);
     mshow;
     for po := 1 to poccom do
     begin
       pocitac[po].pole[otocena1] := pole[otocena1];
       pocitac[po].pole[otocena2] := pole[otocena2];
     end;
     if poradi[rada] = 1 then inc(clovek[pp].spatne);
     if poradi[rada] = 2 then inc(pocitac[pq].spatne);
     inc(rada);
     if rada > pocpor then rada := 1;
     pp := 0;
     pq := 0;
     for po := 1 to rada do
     begin
       if poradi[po] = 1 then inc(pp);
       if poradi[po] = 2 then inc(pq);
     end;
     if poradi[rada] = 2 then
     begin
       poc := random(10);
       if poc > 4 then
       begin
         poc := 0;
         case pocitac[pq].uroven of
           1: for po := 1 to 64 do
              begin
                inc(poc);
                if (pocitac[pq].pole[po] > 0) and (pocitac[pq].pole[po] < 33)
                  and (poc < 5) then pocitac[pq].pole[po] := 0;
              end;
           2: begin
                for po := 1 to 64 do
                begin
                  inc(poc);
                  if (pocitac[pq].pole[po] > 0) and (pocitac[pq].pole[po] < 33)
                    and (poc < 2) then pocitac[pq].pole[po] := 0;
                end;
                poc1 := random(10);
                if poc1 > 4 then
                  for po := 1 to 64 do
                  begin
                    inc(poc);
                    if (pocitac[pq].pole[po] > 0) and (pocitac[pq].pole[po] < 33)
                      and (poc < 3) then pocitac[pq].pole[po] := 0;
                  end;
              end;
           3: for po := 1 to 64 do
              begin
                inc(poc);
                if (pocitac[pq].pole[po] > 0) and (pocitac[pq].pole[po] < 33)
                  and (poc < 2) then pocitac[pq].pole[po] := 0;
              end;
           4: begin
                poc1 := random(10);
                if poc1 > 4 then
                  for po := 1 to 64 do
                  begin
                    inc(poc);
                    if (pocitac[pq].pole[po] > 0) and (pocitac[pq].pole[po] < 33)
                      and (poc < 2) then pocitac[pq].pole[po] := 0;
                  end;
              end;
         end;
       end
       else
       begin
         poc := 0;
         case pocitac[pq].uroven of
           1: for po := 64 downto 1 do
              begin
                inc(poc);
                if (pocitac[pq].pole[po] > 0) and (pocitac[pq].pole[po] < 33)
                  and (poc < 5) then pocitac[pq].pole[po] := 0;
              end;
           2: begin
                for po := 64 downto 1 do
                begin
                  inc(poc);
                  if (pocitac[pq].pole[po] > 0) and (pocitac[pq].pole[po] < 33)
                    and (poc < 2) then pocitac[pq].pole[po] := 0;
                end;
                poc1 := random(10);
                if poc1 > 4 then
                  for po := 64 downto 1 do
                  begin
                    inc(poc);
                    if (pocitac[pq].pole[po] > 0) and (pocitac[pq].pole[po] < 33)
                      and (poc < 3) then pocitac[pq].pole[po] := 0;
                  end;
              end;
           3: for po := 64 downto 1 do
              begin
                inc(poc);
                if (pocitac[pq].pole[po] > 0) and (pocitac[pq].pole[po] < 33)
                  and (poc < 2) then pocitac[pq].pole[po] := 0;
              end;
           4: begin
                poc1 := random(10);
                if poc1 > 4 then
                  for po := 64 downto 1 do
                  begin
                    inc(poc);
                    if (pocitac[pq].pole[po] > 0) and (pocitac[pq].pole[po] < 33)
                      and (poc < 2) then pocitac[pq].pole[po] := 0;
                  end;
              end;
         end;
       end;
     end;
   end
   else
   begin
     otoc[otocena1] := false;
     otoc[otocena2] := false;
     if poradi[rada] = 1 then inc(clovek[pp].spravne);
     if poradi[rada] = 2 then inc(pocitac[pq].spravne);
     for po := 1 to poccom do
     begin
       pocitac[po].pole[otocena1] := 33;
       pocitac[po].pole[otocena2] := 33;
     end;
     if not nechpex then
     begin
       mhide;
       nakpex(33, k1x, k1y);
       nakpex(33, k2x, k2y);
       mshow;
     end;
   end;
   otocena1 := 0;
   otocena2 := 0;
   nakporadi;
 end;
 procedure oznamkonec;
 var
   tabulka: array[1..6] of record
                             jmeno: string[15];
                             body : byte;
                           end;
   pomstr : string;
 begin
   nakpole(false);
   for i := 1 to 6 do
   begin
     tabulka[i].jmeno := '               ';
     tabulka[i].body := 0;
   end;
   if pocpoc <> 0 then
     for i := 1 to pocpoc do
     begin
       tabulka[i].jmeno := clovek[i].jmeno;
       tabulka[i].body := clovek[i].spravne;
     end;
   if poccom <> 0 then
     for i := 1 to poccom do
     begin
       tabulka[i+pocpoc].jmeno := pocitac[i].jmeno;
       tabulka[i+pocpoc].body := pocitac[i].spravne;
     end;
   repeat
     konec := true;
     for i := 1 to 5 do
       if tabulka[i].body < tabulka[i+1].body then
       begin
         konec := false;
         poc1 := tabulka[i].body;
         pomstr := tabulka[i].jmeno;
         tabulka[i].body := tabulka[i+1].body;
         tabulka[i].jmeno := tabulka[i+1].jmeno;
         tabulka[i+1].body := poc1;
         tabulka[i+1].jmeno := pomstr;
       end;
   until konec;
   mhide;
   setfillstyle(1, 7);
   bar(232, 192, 408, 288);
   setcolor(8);
   rectangle(231, 191, 409, 289);
   setcolor(0);
   settextstyle(defaultfont, horizdir, 1);
   outtextxy(240, 200, 'Poad:');
   for i := 1 to pocpor do
   begin
     outtextxy(240, 208+i*9, tabulka[i].jmeno);
     str(tabulka[i].body:2, pomstr);
     outtextxy(384, 208+i*9, pomstr);
   end;
   shadowtext(234, 278, 'Stisknte cokoliv...', 1, 2);
   mshow;
   pressanykey;
 end;
 function jekonec: boolean;
 begin
   k := 1;
   pom := true;
   for j := 0 to 7 do
     for i := 0 to 7 do
     begin
       if otoc[k] then pom := false;
       inc(k);
     end;
   if pom then jekonec := true else jekonec := false;
 end;
 function najdikartu(cislo: byte): byte;
 var
   e, f, g, h: byte;
 begin
   g := 0;
   h := 0;
   py := 4;
   for f := 0 to 7 do
   begin
     px := 4;
     for e := 0 to 7 do
     begin
       inc(g);
       if otoc[g] and (pocitac[pq].pole[g] = cislo) then
       begin
         inc(h);
         if h = 1 then
         begin
           k1x := px;
           k1y := py;
           poc1 := g;
         end;
         if h = 2 then
         begin
           k2x := px;
           k2y := py;
           poc2 := g;
         end;
       end;
       px := px + 59;
     end;
     py := py + 59;
   end;
   najdikartu := h;
 end;
 function prvnivolna(prvni: byte): byte;
 begin
   for i := 1 to 64 do
     if otoc[i] and (i <> prvni) then break;
   prvnivolna := i;
 end;
 procedure comphraje;
 var
   pomp, pokus: byte;
 begin
   poc := 0;
   for i := 1 to 64 do
   begin
     if najdikartu(i) = 2 then
     begin
       poc := 2;
       pomp := i;
     end;
   end;
   if poc = 2 then
   begin
     najdikartu(pomp);
     otocena1 := poc1;
     otocena2 := poc2;
     mhide;
     nakpex(pole[otocena1], k1x, k1y);
     nakpex(pole[otocena2], k2x, k2y);
     mshow;
   end;
   if poc = 0 then
   begin
     pom := false;
     pokus := 0;
     repeat
       poc1 := random(64) + 1;
       if (pocitac[pq].pole[poc1] = 0) and otoc[poc1] then pom := true;
       inc(pokus);
       if pokus > 64 then
       begin
         poc1 := prvnivolna(0);
         pom := true;
       end;
     until pom;
     otocena1 := poc1;
     pom := false;
     pokus := 0;
     repeat
       poc2 := random(64) + 1;
       if (pocitac[pq].pole[poc2] = 0) and otoc[poc2] and (poc2 <> otocena1)
       then pom := true;
       inc(pokus);
       if pokus > 64 then
       begin
         poc2 := prvnivolna(poc1);
         pom := true;
       end;
     until pom;
     otocena2 := poc2;
     py := 4;
     k := 0;
     for j := 0 to 7 do
     begin
       px := 4;
       for i := 0 to 7 do
       begin
         inc(k);
         if k = otocena1 then
         begin
           k1x := px;
           k1y := py;
         end;
         if k = otocena2 then
         begin
           k2x := px;
           k2y := py;
         end;
         px := px + 59;
       end;
       py := py + 59;
     end;
     mhide;
     nakpex(pole[otocena1], k1x, k1y);
     nakpex(pole[otocena2], k2x, k2y);
     mshow;
   end;
   poc := 0;
   repeat
     cekejakci(pom);
     if pom then inc(poc);
     if mouseloc.buttonstatus = leftbutton then ltlac := true;
     if (mouseloc.buttonstatus <> leftbutton) and
       (mouseloc.buttonstatus <> rightbutton) and ltlac then
     begin
       ltlac := false;
       poc := 3;
     end;
     if keypressed then
     begin
       mojekl := kbd;
       if mojekl = 27 then konec := true;
       nuluj;
     end;
   until poc = 3;
   otockarty;
 end;
begin
  konec := false;
  otocena1 := 0;
  otocena2 := 0;
  pp := 0;
  pq := 0;
  for poc := 1 to rada do
  begin
    if poradi[poc] = 1 then inc(pp);
    if poradi[poc] = 2 then inc(pq);
  end;
  poc := 0;
  repeat
    if poradi[rada] = 1 then
    begin
      cekejakci(pom);
      if pom and (otocena2 <> 0) then inc(poc);
      if poc = 3 then
      begin
        poc := 0;
        if otocena2 <> 0 then otockarty;
      end;
      if mouseloc.buttonstatus = leftbutton then ltlac := true;
      if (mouseloc.buttonstatus <> leftbutton) and
        (mouseloc.buttonstatus <> rightbutton) and ltlac then
      begin
        ltlac := false;
        k := 1;
        py := 4;
        for j := 0 to 7 do
        begin
          px := 4;
          for i := 0 to 7 do
          begin
            if inside(px, py, px+58, py+58, x, y) then
            begin
              if otocena2 <> 0 then
              begin
                otockarty;
                delay(100);
              end
              else
              begin
                if (otocena1 = 0) and otoc[k] then
                begin
                  otocena1 := k;
                  k1x := px;
                  k1y := py;
                  mhide;
                  nakpex(pole[k], px, py);
                  mshow;
                  delay(100);
                end;
                if (otocena1 <> 0) and (otocena1 <> k) and (otocena2 = 0) and
                  otoc[k] then
                begin
                  otocena2 := k;
                  k2x := px;
                  k2y := py;
                  mhide;
                  nakpex(pole[k], px, py);
                  mshow;
                  delay(100);
                end;
              end;
            end;
            px := px + 59;
            inc(k);
          end;
          py := py + 59;
        end;
      end;
      if mouseloc.buttonstatus = rightbutton then rtlac := true;
      if (mouseloc.buttonstatus <> rightbutton) and
        (mouseloc.buttonstatus <> leftbutton) and rtlac then
      begin
        rtlac := false;
        pom := nechpex;
        if otocena2 = 0 then menu(prog, 2);
        if pom <> nechpex then nakotoc;
      end;
      if keypressed then
      begin
        mojekl := kbd;
        case mojekl of
          27 : konec := true; {Esc}
          315: if otocena2 = 0 then napoveda(2); {F1}
          324: begin {F10}
                 pom := nechpex;
                 if otocena2 = 0 then menu(prog, 2);
                 if pom <> nechpex then nakotoc;
               end;
        end;
        nuluj;
      end;
    end
    else
      if poradi[rada] = 2 then comphraje;
    if jekonec then oznamkonec;
    if prog then konec := true;
  until konec;
end;

procedure list;
const
  nic1: string[15] = '?              ';
  nic2: string[15] = '               ';
var
  textpole    : array[0..5] of string[15];
  muze, pom   : boolean;
  kam, cnt    : byte;
  vstup       : string[15];
  vybrane, vyb: array[0..5] of boolean;
  urovne      : array[0..5] of byte;
 procedure naknapv;
 begin
   mhide;
   if kam = 6 then shadowtext(getmaxx-110, getmaxy-14, 'F1 - npovda', 1, 1)
   else
   begin
     setfillstyle(1, 7);
     bar(getmaxx-111, getmaxy-15, getmaxx-4, getmaxy-4);
   end;
   mshow;
 end;
 procedure nakpole;
 begin
   py := 120;
   px := 190;
   setfillstyle(1, 13);
   for i := 0 to 5 do
   begin
     bar(px, py, px+260, py+22);
     shadowtext(px+2, py+2, textpole[i], 2, 6);
     py := py + 25;
   end;
 end;
 procedure nakkurzor(jaky: boolean; kamx, kamy: integer);
 begin
   if jaky then
   begin
     setfillstyle(1, 13);
     bar(kamx-1, kamy-1, kamx+17, kamy+17);
     shadowtext(kamx, kamy, '_', 2, 6);
   end
   else
   begin
     setfillstyle(1, 13);
     bar(kamx-1, kamy-1, kamx+17, kamy+17);
   end;
 end;
 procedure overpocet;
 begin
   if pocpoc+poccom > 1 then
   begin
     mhide;
     shadowtext(10, getmaxy-14, 'Stiskem klvesy [Enter] spustte hru.',
       1, 1);
     mshow;
   end
   else
   begin
     mhide;
     setfillstyle(1, 7);
     bar(9, getmaxy-15, 305, getmaxy-4);
     mshow;
   end;
 end;
 procedure zvolcomp;
 var
   uroven, count: byte;
 begin
   vyb[kam-7] := true;
   textpole[kam-7] := nic2;
   mhide;
   shadowtext(18, 100,
     'Vyberte stiskem klves 1..5 rove potae. (1 = nejhor, 5 = nejlep)',
     1, 2);
   mshow;
   muze := false;
   repeat
     cekejakci(pom);
     if mouseloc.buttonstatus = rightbutton then rtlac := true;
     if (mouseloc.buttonstatus <> rightbutton) and
       (mouseloc.buttonstatus <> leftbutton) and rtlac then
     begin
       rtlac := false;
       muze := true;
       uroven := 0;
     end;
     if keypressed then
     begin
       mojekl := kbd;
       case mojekl of
         27: begin {Esc}
               uroven := 0;
               muze := true;
             end;
         49..53: begin {1..5}
               uroven := mojekl - 48;
               muze := true;
             end;
       end;
       nuluj;
     end;
   until muze;
   muze := false;
   count := 0;
   if uroven <> 0 then
   begin
     urovne[kam-7] := uroven;
     for i := 0 to 5 do
       if vyb[i] and (urovne[i] = uroven) then inc(count);
     textpole[kam-7] := jmena[(uroven-1)*6+count];
     inc(poccom);
   end
   else
   begin
     vyb[kam-7] := false;
     textpole[kam-7] := nic1;
   end;
   mhide;
   setfillstyle(1, 7);
   bar(4, 98, getmaxx-4, 110);
   nakpole;
   mshow;
   kam := 6;
   naknapv;
   overpocet;
 end;
begin
  mhide;
  setfillstyle(1, 7);
  bar(2, 2, getmaxx-2, getmaxy-2);
  shadowtext(10, 300, 'Dal hry mete najt na:', 1, 3);
  shadowtext(240, 293, 'www.hamsoft.wz.cz', 2, 14);
  shadowtext(74, 320, 'Pst mi mete na:', 1, 3);
  shadowtext(240, 313, 'louzeckyfilip@seznam.cz', 2, 14);
  shadowtext(178, 340, 'nebo:', 1, 3);
  shadowtext(240, 333, 'ham_soft@volny.cz', 2, 14);
  shadowtext(60, 400, 'Tento program byl napsn v Borland Pascalu v. 7 a je FREEWARE.', 1, 6);
  shadowtext(60, 412, 'To znamen, e ho mete it jak chcete a kam chcete, jen za', 1, 6);
  shadowtext(60, 424, '             to nemete vybrat dn penze!!!!', 1, 6);
  naknap(2, 202, 5);
  for i := 0 to 5 do textpole[i] := nic1;
  nakpole;
  setcolor(8);
  rectangle(187, 117, 453, 270);
  mshow;
  muze := false;
  kam := 6;
  pocpoc := 0;
  poccom := 0;
  for i := 0 to 5 do
  begin
    vybrane[i] := false;
    vyb[i] := false;
    urovne[i] := 0;
  end;
  naknapv;
  repeat
    cekejakci(pom);
    if mouseloc.buttonstatus = leftbutton then ltlac := true;
    if (mouseloc.buttonstatus <> leftbutton) and
      (mouseloc.buttonstatus <> rightbutton) and ltlac then
    begin
      ltlac := false;
      if inside(190, 120, 450, 142, x, y) and not vybrane[0] and (kam = 6)
        and not vyb[0] then
      begin
        kam := 0;
        px := 192;
        py := 122;
        vstup := nic2;
        cnt := 0;
        naknapv;
        mhide;
        nakkurzor(true, px, py);
      end;
      if inside(190, 145, 450, 167, x, y) and not vybrane[1] and (kam = 6)
        and not vyb[1] then
      begin
        kam := 1;
        px := 192;
        py := 147;
        vstup := nic2;
        cnt := 0;
        naknapv;
        mhide;
        nakkurzor(true, px, py);
      end;
      if inside(190, 170, 450, 192, x, y) and not vybrane[2] and (kam = 6)
        and not vyb[2] then
      begin
        kam := 2;
        px := 192;
        py := 172;
        vstup := nic2;
        cnt := 0;
        naknapv;
        mhide;
        nakkurzor(true, px, py);
      end;
      if inside(190, 195, 450, 217, x, y) and not vybrane[3] and (kam = 6)
        and not vyb[3] then
      begin
        kam := 3;
        px := 192;
        py := 197;
        vstup := nic2;
        cnt := 0;
        naknapv;
        mhide;
        nakkurzor(true, px, py);
      end;
      if inside(190, 220, 450, 242, x, y) and not vybrane[4] and (kam = 6)
        and not vyb[4] then
      begin
        kam := 4;
        px := 192;
        py := 222;
        vstup := nic2;
        cnt := 0;
        naknapv;
        mhide;
        nakkurzor(true, px, py);
      end;
      if inside(190, 245, 450, 267, x, y) and not vybrane[5] and (kam = 6)
        and not vyb[5] then
      begin
        kam := 5;
        px := 192;
        py := 247;
        vstup := nic2;
        cnt := 0;
        naknapv;
        mhide;
        nakkurzor(true, px, py);
      end;
    end;
    if mouseloc.buttonstatus = rightbutton then rtlac := true;
    if (mouseloc.buttonstatus <> rightbutton) and
      (mouseloc.buttonstatus <> leftbutton) and rtlac then
    begin
      rtlac := false;
      if inside(190, 120, 450, 142, x, y) then
      begin
        if not vybrane[0] and not vyb[0] and (kam = 6) then
        begin
          kam := 7;
          naknapv;
          zvolcomp;
        end
        else
        begin
          if vybrane[0] then
          begin
            mhide;
            textpole[0] := nic1;
            vybrane[0] := false;
            dec(pocpoc);
            nakpole;
            mshow;
            overpocet;
          end;
          if vyb[0] then
          begin
            mhide;
            textpole[0] := nic1;
            vyb[0] := false;
            dec(poccom);
            nakpole;
            mshow;
            overpocet;
          end;
        end;
      end;
      if inside(190, 145, 450, 167, x, y) then
      begin
        if not vybrane[1] and not vyb[1] and (kam = 6) then
        begin
          kam := 8;
          naknapv;
          zvolcomp;
        end
        else
        begin
          if vybrane[1] then
          begin
            mhide;
            textpole[1] := nic1;
            vybrane[1] := false;
            dec(pocpoc);
            nakpole;
            mshow;
            overpocet;
          end;
          if vyb[1] then
          begin
            mhide;
            textpole[1] := nic1;
            vyb[1] := false;
            dec(poccom);
            nakpole;
            mshow;
            overpocet;
          end;
        end;
      end;
      if inside(190, 170, 450, 192, x, y) then
      begin
        if not vybrane[2] and not vyb[2] and (kam = 6) then
        begin
          kam := 9;
          naknapv;
          zvolcomp;
        end
        else
        begin
          if vybrane[2] then
          begin
            mhide;
            textpole[2] := nic1;
            vybrane[2] := false;
            dec(pocpoc);
            nakpole;
            mshow;
            overpocet;
          end;
          if vyb[2] then
          begin
            mhide;
            textpole[2] := nic1;
            vyb[2] := false;
            dec(poccom);
            nakpole;
            mshow;
            overpocet;
          end;
        end;
      end;
      if inside(190, 195, 450, 217, x, y) then
      begin
        if not vybrane[3] and not vyb[3] and (kam = 6) then
        begin
          kam := 10;
          naknapv;
          zvolcomp;
        end
        else
        begin
          if vybrane[3] then
          begin
            mhide;
            textpole[3] := nic1;
            vybrane[3] := false;
            dec(pocpoc);
            nakpole;
            mshow;
            overpocet;
          end;
          if vyb[3] then
          begin
            mhide;
            textpole[3] := nic1;
            vyb[3] := false;
            dec(poccom);
            nakpole;
            mshow;
            overpocet;
          end;
        end;
      end;
      if inside(190, 220, 450, 242, x, y) then
      begin
        if not vybrane[4] and not vyb[4] and (kam = 6) then
        begin
          kam := 11;
          naknapv;
          zvolcomp;
        end
        else
        begin
          if vybrane[4] then
          begin
            mhide;
            textpole[4] := nic1;
            vybrane[4] := false;
            dec(pocpoc);
            nakpole;
            mshow;
            overpocet;
          end;
          if vyb[4] then
          begin
            mhide;
            textpole[4] := nic1;
            vyb[4] := false;
            dec(poccom);
            nakpole;
            mshow;
            overpocet;
          end;
        end;
      end;
      if inside(190, 245, 450, 267, x, y) then
      begin
        if not vybrane[5] and not vyb[5] and (kam = 6) then
        begin
          kam := 12;
          naknapv;
          zvolcomp;
        end
        else
        begin
          if vybrane[5] then
          begin
            mhide;
            textpole[5] := nic1;
            vybrane[5] := false;
            dec(pocpoc);
            nakpole;
            mshow;
            overpocet;
          end;
          if vyb[5] then
          begin
            mhide;
            textpole[5] := nic1;
            vyb[5] := false;
            dec(poccom);
            nakpole;
            mshow;
            overpocet;
          end;
        end;
      end;
      if (kam >= 0) and (kam <= 5) then
      begin
        nakpole;
        kam := 6;
        mshow;
        naknapv;
      end;
      if not inside(187, 117, 453, 270, x, y) and (kam = 6) then
      begin
        kam := 20;
        naknapv;
        menu(muze, 1);
        kam := 6;
        naknapv;
        prog := muze;
      end;
    end;
    if keypressed then
    begin
      mojekl := kbd;
      if (kam >= 0) and (kam <= 5) then
        case mojekl of
          27: begin {Esc}
                nakpole;
                kam := 6;
                mshow;
                naknapv;
              end;
          13: begin {Enter}
                if cnt <> 0 then
                begin
                  nakkurzor(false, px+cnt*16, py);
                  textpole[kam] := vstup;
                  vybrane[kam] := true;
                  inc(pocpoc);
                  kam := 6;
                  mshow;
                  naknapv;
                  overpocet;
                end;
              end;
          8 : begin {BackSpace}
                if cnt <> 0 then
                begin
                  vstup[cnt] := ' ';
                  nakkurzor(false, px+cnt*16, py);
                  dec(cnt);
                  nakkurzor(true, px+cnt*16, py);
                end;
              end;
          65..90, 97..122, 32, 48..57, 130, 133, 144, 155, 156, 159, 160, 161,
            162, 163, 166, 167, 172, 181, 183, 210, 212, 213, 214, 216, 222,
            224, 229, 230, 231, 233, 236, 237, 252, 253: {A..Z, a..z,  , 0..9,
            , , , , , , , , , , , , , , , , , , , , , ,
            , , , , , , , }
              begin
                if cnt <> 15 then
                begin
                  nakkurzor(false, px+cnt*16, py);
                  shadowtext(px+cnt*16, py, chr(mojekl), 2, 6);
                  inc(cnt);
                  vstup[cnt] := chr(mojekl);
                  nakkurzor(true, px+cnt*16, py);
                end;
              end;
        end
      else
        case mojekl of
          324: begin {F10}
                 kam := 20;
                 naknapv;
                 menu(muze, 1);
                 kam := 6;
                 naknapv;
                 prog := muze;
               end;
          315: begin {F1}
                 kam := 20;
                 naknapv;
                 napoveda(1);
                 kam := 6;
                 naknapv;
               end;
          13 : begin {Enter}
                 if pocpoc+poccom > 1 then
                 begin
                   prog := false;
                   muze := true;
                 end;
               end;
          70 : begin {F}
                 if insert then
                 begin
                   prog := false;
                   muze := true;
                   cheat := true;
                 end;
               end;
        end;
      nuluj;
    end;
  until muze;
  if not prog and not cheat then
  begin
    j := 0;
    k := 0;
    for i := 0 to 5 do
    begin
      if vybrane[i] then
      begin
        inc(j);
        clovek[j].jmeno := textpole[i];
        clovek[j].spatne := 0;
        clovek[j].spravne := 0;
      end;
      if vyb[i] then
      begin
        inc(k);
        pocitac[k].jmeno := textpole[i];
        pocitac[k].uroven := urovne[i];
        pocitac[k].spatne := 0;
        pocitac[k].spravne := 0;
        for cnt := 1 to 64 do pocitac[k].pole[cnt] := 0;
      end;
    end;
    for i := 1 to 6 do poradi[i] := 0;
    j := 0;
    for i := 0 to 5 do
    begin
      if vybrane[i] then
      begin
        inc(j);
        poradi[j] := 1;
      end;
      if vyb[i] then
      begin
        inc(j);
        poradi[j] := 2;
      end;
    end;
    pocpor := pocpoc + poccom;
    rada := 1;
  end;
end;

begin
  writeln;
  write('Alokace pamti: ');
  if maxavail < ((sizeof(tobr)*33)+sizeof(tbig)+sizeof(tsmall)) then
  begin
    writeln('Nedostatek pamti!');
    halt;
  end;
  zaberpamet;
  write((sizeof(tobr)*33+sizeof(tbig)+sizeof(tsmall)), ' bajt, ');
  writeln('Ok');
  nactiobrazky;
  write('Zjiovn konfigurace: ');
  nechpex := false;
  assign(cfgfile, 'PEXESO.CFG');
  {$i-}
  reset(cfgfile);
  {$i+}
  if ioresult <> 0 then
    writeln('Nemohu nast soubor PEXESO.CFG! Nevad, mohu pokraovat i bez toho.')
  else
  begin
    read(cfgfile, nechpex);
    close(cfgfile);
    writeln('Ok');
  end;
  write('Zjiovn ptomnosti ovladae myi: ');
  aktivujmys;
  writeln('Ok');
  if (paramcount <> 0) and (paramstr(1) = '-STEPBYSTEP') then
  begin
    writeln('Stisknte cokoliv pro pokraovn...');
    pressanykey;
  end;
  writeln('Inicializace grafiky...');
  registerbgidriver(@vgadriver);
  gd := vga;
  gm := vgahi;
  initgraph(gd, gm, '');
  if graphresult <> 0 then
  begin
    uvolnipamet;
    writeln('Graph error #', graphresult, ': ', grapherrormsg(graphresult));
    halt;
  end;
  setrgbpalette(20, 63, 40, 0);
  setrgbpalette(61, 63, 53, 30);
  setfillstyle(1, 7);
  bar(2, 2, getmaxx-2, getmaxy-2);
  setcolor(8);
  rectangle(0, 0, getmaxx, getmaxy);
  rectangle(1, 1, getmaxx-1, getmaxy-1);
  uvod;
  wait(5);
  randomize;
  prog := false;
  cheat := false;
  pocpoc := 0;
  poccom := 0;
  mshow;
  repeat
    list;
    if not prog and not cheat then novahra;
    if not prog and not cheat then hra;
    if cheat then prohlednout;
  until prog;
  mhide;
  closegraph;
  uvolnipamet;
  textcolor(7); textbackground(0); clrscr;
  assign(cfgfile, 'PEXESO.CFG');
  {$i-}
  rewrite(cfgfile);
  {$i+}
  if ioresult <> 0 then
    writeln('Nemohu zapisovat do souboru PEXESO.CFG!')
  else
  begin
    write(cfgfile, nechpex);
    close(cfgfile);
  end;
  textcolor(15); textbackground(1);
  write('ham');
  textcolor(4); textbackground(0);
  write(' SOFTWARE');
  textcolor(7);
  textbackground(0);
  writeln('');
  writeln('Pexeso, napsal Filip Loueck v r. 2006');
  writeln('');
end.