unit un_kbd;

interface

uses
  mouse;

var
  x, y, oldx, oldy     : integer;
  themouse             : resetrec;
  mouseloc             : locrec;
  klav                 : char;
  counter, ltlac, rtlac: boolean;
  mojekl, h, m, s, ss,
  h_, m_, s_, ss_      : word;

function inside(x1, y1, x2, y2, x, y: integer): boolean;
function pocitadlo: boolean;
function rshift: boolean;
function lshift: boolean;
function ctrl: boolean;
function alt: boolean;
function scroll: boolean;
function num: boolean;
function caps: boolean;
function insert: boolean;
procedure nuluj;
function kbd: word;
procedure pressanykey;
procedure cekejakci(var pom: boolean);
procedure aktivujmys;
procedure wait(kolik: byte);

implementation

uses
  dos, crt;

var
  pom          : word;

function inside(x1, y1, x2, y2, x, y: integer): boolean;
begin
  inside := (x1 <= x) and (y1 <= y) and (x2 >= x) and (y2 >= y);
end;

function pocitadlo: boolean;
begin
  gettime(h, m, s, ss);
  if (h<>h_) or (m<>m_) or (s<>s_) then
  begin
    h_ := h; m_ := m; s_ := s;
    pocitadlo := true;
  end
  else pocitadlo := false;
end;

function rshift: boolean;
begin
  if mem[0:$417] and $01 > 0 then rshift := true
  else rshift := false;
end;

function lshift: boolean;
begin
  if mem[0:$417] and $02 > 0 then lshift := true
  else lshift := false;
end;

function ctrl: boolean;
begin
  if mem[0:$417] and $04 > 0 then ctrl := true
  else ctrl := false;
end;

function alt: boolean;
begin
  if mem[0:$417] and $08 > 0 then alt := true
  else alt := false;
end;

function scroll: boolean;
begin
  if mem[0:$417] and $10 > 0 then scroll := true
  else scroll := false;
end;

function num: boolean;
begin
  if mem[0:$417] and $20 > 0 then num := true
  else num := false;
end;

function caps: boolean;
begin
  if mem[0:$417] and $40 > 0 then caps := true
  else caps := false;
end;

function insert: boolean;
begin
  if mem[0:$417] and $80 > 0 then insert := true
  else insert := false;
end;

procedure nuluj;
begin
  mojekl := 0;
end;

function kbd: word;
var
  klav: char;
begin
  klav := readkey;
  if klav = #0 then
  begin
    klav := readkey;
    kbd := ord(klav) + 256;
  end
  else kbd := ord(klav);
end;

procedure pressanykey;
begin
  repeat
    mpos(mouseloc);
  until keypressed or (mouseloc.buttonstatus <> 0);
  if keypressed then pom := kbd;
  nuluj;
end;

procedure cekejakci(var pom: boolean);
begin
  repeat
    if pocitadlo then pom := true
    else pom := false;
    mpos(mouseloc);
    x := mouseloc.column;
    y := mouseloc.row;
  until keypressed or (oldx <> x) or (oldy <> y) or (mouseloc.buttonstatus <> 0) or ltlac or rtlac or pom;
  oldx := x;
  oldy := y;
end;

procedure aktivujmys;
begin
  mreset(themouse);
  if not themouse.exists then
  begin
    writeln('My nen ptomna. Nainstalujte prosm jej ovlada.');
    halt;
  end;
end;

procedure wait(kolik: byte);
var
  pom: byte;
begin
  pom := 0;
  repeat
    gettime(h, m, s, ss);
    if (h<>h_) or (m<>m_) or (s<>s_) then
    begin
      h_ := h; m_ := m; s_ := s;
      inc(pom);
    end;
  until pom = kolik;
end;

begin
  oldx := 0;
  oldy := 0;
end.